<template>
<div class="col-12 text-center h2">
	{{currentText}}
</div>
</template>

<script>

async function wait(min,max){
	return new Promise(resolve => setTimeout( resolve, Math.floor(min + Math.random() * (max - min))))
}


export default {
	name: "TextRunner",
	props: {
		texts: Array
	},
	data: function(){
		return {
			currentText: ""
		}
	},
	mounted: function(){
		this.animationLoop();
	},
	methods:{
		animationLoop: async function(){
			// eslint-disable-next-line no-constant-condition
			while (true) {
				
				// Decide next item
				const nextIndex = Math.floor(Math.random() * this.texts.length);
				this.$emit("next-index",nextIndex);
				const next = this.texts.length > 0 ? this.texts[nextIndex] : ""
				if (typeof next !== "string") {
					throw new TypeError("Given Texts all need to be strings")
				}

				// Tear Down
				{
				
					await wait(200, 500)
					
					while (this.currentText.length > 0) {
						this.currentText = this.currentText.substring(0, this.currentText.length - 1)
						await wait(50,70)
					}
				}
				
				await wait(200, 300)

				// Build Up
				for (let i = this.currentText.length; i < next.length; i++) {
					this.currentText += next[i]
					await wait(50, 100)
				}
				
				await wait(1000, 2000)
			}

		}
	}
}
</script>

<style>

</style>